---
title: Firefox 14 for developers
slug: Mozilla/Firefox/Releases/14
tags:
  - Firefox
  - Firefox 14
  - Gecko
  - Gecko 14
---
<div>{{FirefoxSidebar}}</div>

<p>Firefox 14 shipped on July 17, 2012. This article lists key changes that are useful for not only Web developers to know about, but also Firefox and Gecko developers as well as add-on developers.</p>

<h2 id="Changes_for_Web_developers">Changes for Web developers</h2>

<h3 id="HTML">HTML</h3>

<ul>
 <li>The {{HTMLElement("progress")}} element is no longer incorrectly classified as a form element, and therefore no longer has a <code>form</code> attribute.</li>
 <li>The default modifier keys for the <code><a href="/en-US/docs/HTML/Global_attributes" title="Global attributes">accesskey</a></code> of HTML contents on Mac are changed to Control+Option. This is the same as WebKit-based browsers on Mac.</li>
</ul>

<h3 id="DOM">DOM</h3>

<ul>
 <li><a href="/en-US/docs/DOM/DOM_event_reference/input" title="input">input</a> events are fired also on editing host element of <a href="/en-US/docs/DOM/Element.contentEditable" title="Element.contentEditable">contenteditable</a> editor and root element of <a href="/en-US/docs/DOM/document.designMode" title="document.designMode">designMode</a> editor.</li>
 <li>{{domxref("DOMException", "DOMException.code")}} is now deprecated per latest DOM Level 4 specification.</li>
 <li>The {{domxref("Range.insertNode()")}} method now works correctly when used on collapsed ranges.</li>
 <li>The {{domxref("BlobBuilder", "MozBlobBuilder")}} interface has been deprecated in favor of the constructor on {{domxref("Blob")}}. If you use <code>MozBlobBuilder</code> you'll see a warning message in the Web Console.</li>
 <li>The {{domxref("Blob.Blob", "Blob()")}} constructor is now available to workers ({{bug(736686)}}).</li>
 <li>Support for the <a href="/en-US/docs/DOM/DOM_Mutation_Observers" title="DOM/DOM_Mutation_Observers">Mutation Observers</a> has been landed. It is designed as a replacement for the Mutation Events in DOM3, which has a number of issues regarding performance.</li>
 <li>The {{domxref("HTMLImageElement")}} interface's <code>x</code> and <code>y</code> properties were removed in Gecko 7.0 {{geckoRelease("7.0")}} but restored in this release for compatibility reasons.</li>
 <li>The {{domxref("Document")}} methods <code>execCommandShowHelp()</code> and <code>queryCommandText()</code>, which never did anything, have been removed.</li>
 <li>The <code>GeoPositionAddress</code> interface, an obsolete part of the <a href="/en-US/docs/Using_geolocation" title="Using_geolocation">Geolocation</a> API, has been removed.</li>
 <li>{{domxref("Storage", "localStorage/sessionStorage")}} now correctly return <code>undefined</code> instead of <code>null</code> for undeclared keys through property access.ff</li>
 <li>The {{domxref("ImageData")}} object has been implemented ({{bug(550309)}}).</li>
 <li>Attributes and methods related to child nodes on {{domxref("Attr")}} interface where obsoleted ({{bug(737122)}}).</li>
</ul>

<h3 id="CSS">CSS</h3>

<ul>
 <li>The {{cssxref("text-transform")}} and {{cssxref("font-variant")}} CSS properties have been fixed to correctly handle the <code>i</code> → <code>İ</code> and <code>ı</code> → <code>I</code> <a href="http://en.wikipedia.org/wiki/Turkic_languages">Turkic</a>-specific case pairs.</li>
 <li>The Dutch IJ digraph is now correctly handled by <code>text-transform: capitalization</code>. Similarly the Greek letter <code>Σ</code>, which has two lowercase forms, <code>σ</code> and <code>ς</code>, is now correctly handled by <code>text-transform: lowercase</code>.</li>
 <li>Support for the <code>skew()</code> function has been removed from {{cssxref("transform")}} property, as it has been removed from the draft standard.</li>
 <li>The syntax for {{cssxref("border-image")}} has been updated to match the latest revision of the specification; it no longer accepts a trailing slash ("/").</li>
</ul>

<h3 id="JavaScript">JavaScript</h3>

<p><em>No change.</em></p>

<h3 id="MathML">MathML</h3>

<ul>
 <li>The syntax of the <code>statusline</code> action type on {{MathMLElement("maction")}} elements has been adjusted to follow the MathML specification.</li>
</ul>

<h3 id="HTTP">HTTP</h3>

<ul>
 <li>Gecko now supports the new <a href="/en-US/docs/HTTP" title="HTTP">HTTP</a> <a href="/en-US/docs/HTTP/HTTP_response_codes#308" title="https://developer.mozilla.org/en-US/docs/HTTP/HTTP_response_codes#308"><code>308 Permanent Redirect</code></a> status code. As Gecko doesn't make a distinction between permanent and temporary redirects, it behaves like the <a href="/en-US/docs/HTTP/HTTP_response_codes#307" title="https://developer.mozilla.org/en-US/docs/HTTP/HTTP_response_codes#307"><code>307 Temporary Redirect</code></a> status code, as it forbids the user agent from changing the HTTP method used between the two requests (<code>POST</code> will stay <code>POST</code>, <code>GET</code> will stay <code>GET</code>).</li>
</ul>

<h2 id="Changes_for_Mozilla_and_add-on_developers">Changes for Mozilla and add-on developers</h2>

<h3 id="JavaScript_code_modules">JavaScript code modules</h3>

<h4 id="source-editor.jsm">source-editor.jsm</h4>

<ul>
 <li>Added a keyboard shortcut to toggle commenting for the current selection (Ctrl-/ or Cmd-/ on Mac OS X).</li>
 <li>Added the Ctrl-[ and Ctrl-] keyboard shortcuts for moving the text input position to the beginning and end of the current block.</li>
 <li>Added the new <a href="/en-US/docs/JavaScript_code_modules/source-editor.jsm#getLineStart%28%29" title="JavaScript_code_modules/source-editor.jsm#getLineStart%28%29"><code>getLineStart()</code></a> and <a href="/en-US/docs/JavaScript_code_modules/source-editor.jsm#getLineEnd%28%29" title="JavaScript_code_modules/source-editor.jsm#getLineEnd%28%29"><code>getLineEnd()</code></a> methods.</li>
</ul>

<h3 id="XUL">XUL</h3>

<ul>
 <li>Added the new {{XULAttr("fullscreenbutton")}} attribute to the {{XULElem("window")}} element; setting this to <code>true</code> adds a button to the window's chrome to enable full screen mode.</li>
</ul>

<h3 class="editable" id="Interfaces">Interfaces</h3>

<ul>
 <li>The {{interface("nsILocalFile")}} interface has been merged into {{interface("nsIFile")}} (<a class="link-https" href="https://bugzilla.mozilla.org/show_bug.cgi?id=682360">bug 682360</a>).</li>
 <li>The methods in {{interface("nsIPlacesImportExportService")}} for importing bookmarks have all been removed in favor of the <code><a href="/en-US/docs/JavaScript_code_modules/BookmarkHTMLUtils.jsm" title="JavaScript_code_modules/BookmarkHTMLUtils.jsm">BookmarkHTMLUtils.jsm</a></code> JavaScript code module.</li>
 <li>The {{interface("nsIDOMGeoPositionAddress")}} interface has been removed.</li>
 <li>The <code>getItemGUID</code>, <code>setItemGUID</code> and <code>getItemIdForGUID</code> methods have been removed from {{interface("nsINavBookmarksService")}} ({{bug("715355")}}).</li>
</ul>

<h3 id="Spellchecking">Spellchecking</h3>

<ul>
 <li>Dictionary names are now parsed as full <a href="http://tools.ietf.org/html/bcp47">BCP 47</a> language tags (<a class="link-https" href="https://bugzilla.mozilla.org/show_bug.cgi?id=730209">bug 730209</a>, <a class="link-https" href="https://bugzilla.mozilla.org/show_bug.cgi?id=741842">bug 741842</a>). Developers are encouraged to not hard-code the name of their language in their dictionary names.</li>
</ul>

<h2 id="See_also">See also</h2>

<div>{{Firefox_for_developers('13')}}</div>
